using UnityEngine;

namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static void Main()
        {
            CategoryBuilder.Create("Hazardous Materials Unleashed: Alpha", "Contains H.E.V. Suits, weapons, etc. (More things coming soon!)", ModAPI.LoadSprite("icons/category.png"));

            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                NameOverride = "H.E.V. Suit Mark 4 -HMU: A", //new item name with a suffix to assure it is globally unique
                DescriptionOverride = "Hazardous Environments Vest Mark 4 from Black Mesa. Protects from sharp weapons and is pretty powerful.", //new item description
                CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/gordon1.png"), //new item thumbnail (relative path)
                AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                {
                    //load textures for each layer (see Human textures folder in this repository)
                    var skin = ModAPI.LoadTexture("sprites/hev_mark4_dude.png");
                    var flesh = ModAPI.LoadTexture("sprites/fleshthing.png");
                    var bone = ModAPI.LoadTexture("sprites/boneguy_lol.png");

                    //get person
                    //get person
                                var person = Instance.GetComponent<PersonBehaviour>();


                    	    foreach (var head in person.Limbs)
                                            {
                                                head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                            }

                                person.SetBodyTextures(skin, flesh, bone, 1);

                                            foreach (var body in person.Limbs)
                                            {

                                                 body.Health *= 1.5f;
                                            }
                }
            }
        );
        ModAPI.Register(
        new Modification()
        {
            OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
            NameOverride = "H.E.V. Mark 4 (Helmet version) -HMU: A", //new item name with a suffix to assure it is globally unique
            DescriptionOverride = "Hazardous Environments Vest Mark 4 with helmet. Used by scientists.", //new item description
            CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
            ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/scientist.png"), //new item thumbnail (relative path)
            AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
            {
                //load textures for each layer (see Human textures folder in this repository)
                var skin = ModAPI.LoadTexture("sprites/hev_mark4_withhelmet.png");
                var flesh = ModAPI.LoadTexture("sprites/fleshthing.png");
                var bone = ModAPI.LoadTexture("sprites/boneguy_lol.png");

                //get person
                //get person
                var person = Instance.GetComponent<PersonBehaviour>();


          foreach (var head in person.Limbs)
                            {
                                head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            }

                person.SetBodyTextures(skin, flesh, bone, 1);

                            foreach (var body in person.Limbs)
                            {

                                 body.Health *= 1.5f;
                            }
            }
        }
    );
        ModAPI.Register(
        new Modification()
        {
            OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
            NameOverride = "H.E.V. Mark 4 (Red Variant) -HMU: A", //new item name with a suffix to assure it is globally unique
            DescriptionOverride = "H.E.V. Suit Mark 4, Colette Green color version.", //new item description
            CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
            ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/colette.png"), //new item thumbnail (relative path)
            AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
            {
                //load textures for each layer (see Human textures folder in this repository)
                var skin = ModAPI.LoadTexture("sprites/hev_colette_dude.png");
                var flesh = ModAPI.LoadTexture("sprites/fleshthing.png");
                var bone = ModAPI.LoadTexture("sprites/boneguy_lol.png");

                //get person
                //get person
                var person = Instance.GetComponent<PersonBehaviour>();


          foreach (var head in person.Limbs)
                            {
                                head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            }

                person.SetBodyTextures(skin, flesh, bone, 1);

                            foreach (var body in person.Limbs)
                            {

                                 body.Health *= 1.5f;
                            }
            }
        }
    );
    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "H.E.V. Mark 4 (Beige Variant) -HMU: A", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "H.E.V. Suit Mark 4, Gina Cross color version.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/gina.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("sprites/hev_gina_dude.png");
            var flesh = ModAPI.LoadTexture("sprites/fleshthing.png");
            var bone = ModAPI.LoadTexture("sprites/boneguy_lol.png");

            //get person
            //get person
            var person = Instance.GetComponent<PersonBehaviour>();


      foreach (var head in person.Limbs)
                        {
                            head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        }

            person.SetBodyTextures(skin, flesh, bone, 1);

                        foreach (var body in person.Limbs)
                        {

                             body.Health *= 1.5f;
                        }
        }
    }
);
        ModAPI.Register(
        new Modification()
        {
            OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
            NameOverride = "H.E.V. Suit Mark 5 -HMU: A", //new item name with a suffix to assure it is globally unique
            DescriptionOverride = "Hazardous Environments Vest Mark 5 from Kleiner's Laboratory. Stronger than Mark 4, i guess...", //new item description
            CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
            ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/gordon2.png"), //new item thumbnail (relative path)
            AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
            {
                //load textures for each layer (see Human textures folder in this repository)
                var skin = ModAPI.LoadTexture("sprites/hev_mark5_cool_dude.png");
                var flesh = ModAPI.LoadTexture("sprites/fleshthing.png");
                var bone = ModAPI.LoadTexture("sprites/boneguy_lol.png");

                //get person
                //get person
                var person = Instance.GetComponent<PersonBehaviour>();


          foreach (var head in person.Limbs)
                            {
                                head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            }

                person.SetBodyTextures(skin, flesh, bone, 1);

                            foreach (var body in person.Limbs)
                            {

                                 body.Health *= 1.5f;
                            }
            }
        }
        );
        ModAPI.Register(
        new Modification()
        {
            OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
            NameOverride = "Ivan The Biker (H.E.V. Mark 1???) -HMU: A", //new item name with a suffix to assure it is globally unique
            DescriptionOverride = "I made it because i was bored.", //new item description
            CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
            ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/kaka1337.png"), //new item thumbnail (relative path)
            AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
            {
                //load textures for each layer (see Human textures folder in this repository)
                var skin = ModAPI.LoadTexture("sprites/hev_ivan_bruh.png");
                var flesh = ModAPI.LoadTexture("sprites/fleshthing.png");
                var bone = ModAPI.LoadTexture("sprites/boneguy_lol.png");

                //get person
                //get person
                var person = Instance.GetComponent<PersonBehaviour>();


          foreach (var head in person.Limbs)
                            {
                                head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            }

                person.SetBodyTextures(skin, flesh, bone, 1);

                            foreach (var body in person.Limbs)
                            {

                                 body.Health *= 1.5f;
                            }
            }
        }
        );
        ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Physics Gun"), //item to derive from
        NameOverride = "Gravity Gun -HMU: A (TESTING PROTOTYPE DONT USE PLEASE)", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Zero Point Energy Field Manipulator (AKA Gravity Gun), made in Black Mesa East.", //new item description
        CategoryOverride = ModAPI.FindCategory("Misc."), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/gravity_gun.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("tool_sprites/gravity_gun.png"); //get the SpriteRenderer and replace its sprite with a custom one
        }
    }
);
ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Hammer"), //item to derive from
NameOverride = "Crowbar -HMU: A", //new item name with a suffix to assure it is globally unique
DescriptionOverride = "A normal crowbar, duh.", //new item description
CategoryOverride = ModAPI.FindCategory("Melee"), //new item category
ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/crowbar.png"), //new item thumbnail (relative path)
AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
{
    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/crowbar.png"); //get the SpriteRenderer and replace its sprite with a custom one
}
}
);
ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Pistol"),
      NameOverride = "Glock 17 -HMU: A",
      DescriptionOverride = "9mm pistol used in Black Mesa.",
      CategoryOverride = ModAPI.FindCategory("Firearms"),
      ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/glock.png"),
      AfterSpawn = (Instance) =>
      {
          //This line of code sets the sprite after the gun is spawned in.
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/glock.png");
          //Since we'll be referencing this a few times in the code, it's better to cache it here to save like, a couple of nanoseconds. I guess.
          var firearm = Instance.GetComponent<FirearmBehaviour>();

          //The way most guns work in People Playground is by taking a ScriptableObject called "Cartridge", and loading it into the FirearmBehaviour. Some things here are self-explanatory.
          Cartridge customCartridge = ModAPI.FindCartridge("9mm");
          //In order to get a baseline of the Cartridge, it's easier to load in a pre-existing one. A list of the game's cartridges will be found underneath this.
          customCartridge.name = "9mm";
          //set a new name for the new cartridge
          customCartridge.Damage *= 5f;
          //notice that this is using *= instead of =, that's because it's modifying the original cartridge's values instead of setting them from scratch.
          customCartridge.StartSpeed *= 0.5f; //Bullet velocity
          customCartridge.Recoil *= 2f;
          customCartridge.PenetrationRandomAngleMultiplier *= 0.25f; //Changes the accuracy of a bullet after colliding with an object.
          customCartridge.ImpactForce *= 2f; //The force applied once the bullet makes collides

          //remember that variable we bullied earlier? this is him now. a gun. i bet you feel stupid
          firearm.Cartridge = customCartridge;

          //This array is randomly picked from when the gun is fired.
          firearm.ShotSounds = new AudioClip[]
          {
              ModAPI.LoadSound("sounds/pistol.wav")
          };
      }
  }
);
ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Revolver"),
      NameOverride = "Colt Python -HMU: A",
      DescriptionOverride = ".38 Special Colt Python revolver used in Black Mesa.",
      CategoryOverride = ModAPI.FindCategory("Firearms"),
      ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/python.png"),
      AfterSpawn = (Instance) =>
      {
          //This line of code sets the sprite after the gun is spawned in.
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/colt_python.png");
          //Since we'll be referencing this a few times in the code, it's better to cache it here to save like, a couple of nanoseconds. I guess.
          var firearm = Instance.GetComponent<FirearmBehaviour>();

          //The way most guns work in People Playground is by taking a ScriptableObject called "Cartridge", and loading it into the FirearmBehaviour. Some things here are self-explanatory.
          Cartridge customCartridge = ModAPI.FindCartridge("38 Special");
          //In order to get a baseline of the Cartridge, it's easier to load in a pre-existing one. A list of the game's cartridges will be found underneath this.
          customCartridge.name = "38 Special";
          //set a new name for the new cartridge
          customCartridge.Damage *= 5f;
          //notice that this is using *= instead of =, that's because it's modifying the original cartridge's values instead of setting them from scratch.
          customCartridge.StartSpeed *= 0.5f; //Bullet velocity
          customCartridge.Recoil *= 2f;
          customCartridge.PenetrationRandomAngleMultiplier *= 0.25f; //Changes the accuracy of a bullet after colliding with an object.
          customCartridge.ImpactForce *= 2f; //The force applied once the bullet makes collides

          //remember that variable we bullied earlier? this is him now. a gun. i bet you feel stupid
          firearm.Cartridge = customCartridge;

          //This array is randomly picked from when the gun is fired.
          firearm.ShotSounds = new AudioClip[]
          {
              ModAPI.LoadSound("sounds/357_shot1.wav"),
              ModAPI.LoadSound("sounds/357_shot2.wav")
          };
      }
  }
);
ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
      NameOverride = "MP5 -HMU: A",
      DescriptionOverride = "9mm SMG used in Black Mesa. Has underbarrel grenade launcher (doesn't actually work though.)",
      CategoryOverride = ModAPI.FindCategory("Firearms"),
      ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/mp5.png"),
      AfterSpawn = (Instance) =>
      {
          //This line of code sets the sprite after the gun is spawned in.
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/mp5.png");
          //Since we'll be referencing this a few times in the code, it's better to cache it here to save like, a couple of nanoseconds. I guess.
          var firearm = Instance.GetComponent<FirearmBehaviour>();

          //The way most guns work in People Playground is by taking a ScriptableObject called "Cartridge", and loading it into the FirearmBehaviour. Some things here are self-explanatory.
          Cartridge customCartridge = ModAPI.FindCartridge("9mm");
          //In order to get a baseline of the Cartridge, it's easier to load in a pre-existing one. A list of the game's cartridges will be found underneath this.
          customCartridge.name = "9mm";
          //set a new name for the new cartridge
          customCartridge.Damage *= 5f;
          //notice that this is using *= instead of =, that's because it's modifying the original cartridge's values instead of setting them from scratch.
          customCartridge.StartSpeed *= 0.5f; //Bullet velocity
          customCartridge.Recoil *= 2f;
          customCartridge.PenetrationRandomAngleMultiplier *= 0.25f; //Changes the accuracy of a bullet after colliding with an object.
          customCartridge.ImpactForce *= 2f; //The force applied once the bullet makes collides

          //remember that variable we bullied earlier? this is him now. a gun. i bet you feel stupid
          firearm.Cartridge = customCartridge;

          //This array is randomly picked from when the gun is fired.
          firearm.ShotSounds = new AudioClip[]
          {
              ModAPI.LoadSound("sounds/mp51.wav"),
              ModAPI.LoadSound("sounds/mp52.wav")
          };
      }
  }
);
ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Shotgun"),
      NameOverride = "SPAS-12 -HMU: A",
      DescriptionOverride = "SPAS-12 gun. Lmao.",
      CategoryOverride = ModAPI.FindCategory("Firearms"),
      ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/spas.png"),
      AfterSpawn = (Instance) =>
      {
          //This line of code sets the sprite after the gun is spawned in.
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/spas_12.png");
          //Since we'll be referencing this a few times in the code, it's better to cache it here to save like, a couple of nanoseconds. I guess.
          var firearm = Instance.GetComponent<FirearmBehaviour>();

          //The way most guns work in People Playground is by taking a ScriptableObject called "Cartridge", and loading it into the FirearmBehaviour. Some things here are self-explanatory.
          Cartridge customCartridge = ModAPI.FindCartridge("30-06");
          //In order to get a baseline of the Cartridge, it's easier to load in a pre-existing one. A list of the game's cartridges will be found underneath this.
          customCartridge.name = "30-06";
          //set a new name for the new cartridge
          customCartridge.Damage *= 5f;
          //notice that this is using *= instead of =, that's because it's modifying the original cartridge's values instead of setting them from scratch.
          customCartridge.StartSpeed *= 0.5f; //Bullet velocity
          customCartridge.Recoil *= 3f;
          customCartridge.PenetrationRandomAngleMultiplier *= 0.25f; //Changes the accuracy of a bullet after colliding with an object.
          customCartridge.ImpactForce *= 3f; //The force applied once the bullet makes collides

          //remember that variable we bullied earlier? this is him now. a gun. i bet you feel stupid
          firearm.Cartridge = customCartridge;

          //This array is randomly picked from when the gun is fired.
          firearm.ShotSounds = new AudioClip[]
          {
              ModAPI.LoadSound("sounds/spas_12.wav")
          };
      }
  }
);
ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
      NameOverride = "M16 Assault Rifle -HMU: A",
      DescriptionOverride = "M16 assault rifle with underbarrel grenade launcher, used by HECU.",
      CategoryOverride = ModAPI.FindCategory("Firearms"),
      ThumbnailOverride = ModAPI.LoadSprite("spawnable_icons/m16.png"),
      AfterSpawn = (Instance) =>
      {
          //This line of code sets the sprite after the gun is spawned in.
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/m16.png");
          //Since we'll be referencing this a few times in the code, it's better to cache it here to save like, a couple of nanoseconds. I guess.
          var firearm = Instance.GetComponent<FirearmBehaviour>();

          //The way most guns work in People Playground is by taking a ScriptableObject called "Cartridge", and loading it into the FirearmBehaviour. Some things here are self-explanatory.
          Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
          //In order to get a baseline of the Cartridge, it's easier to load in a pre-existing one. A list of the game's cartridges will be found underneath this.
          customCartridge.name = "5.56x45mm";
          //set a new name for the new cartridge
          customCartridge.Damage *= 5f;
          //notice that this is using *= instead of =, that's because it's modifying the original cartridge's values instead of setting them from scratch.
          customCartridge.StartSpeed *= 0.5f; //Bullet velocity
          customCartridge.Recoil *= 2f;
          customCartridge.PenetrationRandomAngleMultiplier *= 0.25f; //Changes the accuracy of a bullet after colliding with an object.
          customCartridge.ImpactForce *= 2f; //The force applied once the bullet makes collides

          //remember that variable we bullied earlier? this is him now. a gun. i bet you feel stupid
          firearm.Cartridge = customCartridge;

          //This array is randomly picked from when the gun is fired.
          firearm.ShotSounds = new AudioClip[]
          {
              ModAPI.LoadSound("sounds/rifle.wav")
          };
      }
  }
);
ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
    NameOverride = "H.E.V. Mark 4 (Alt Color )-HMU: A", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = "H.E.V. Mark 4 suit with multiplayer model colors. Looks kinda cool.", //new item description
    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("sprites/hev_mark4_withhelmet_multiplayerver.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //load textures for each layer (see Human textures folder in this repository)
        var skin = ModAPI.LoadTexture("sprites/hev_mark4_withhelmet_multiplayerver.png");
        var flesh = ModAPI.LoadTexture("sprites/fleshthing.png");
        var bone = ModAPI.LoadTexture("sprites/boneguy_lol.png");

        //get person
        //get person
                    var person = Instance.GetComponent<PersonBehaviour>();


              foreach (var head in person.Limbs)
                                {
                                    head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                }

                    person.SetBodyTextures(skin, flesh, bone, 1);

                                foreach (var body in person.Limbs)
                                {

                                     body.Health *= 1.5f;
                                }
    }
}
);
ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
    NameOverride = "H.E.V. Mark 4 (Early version Color )-HMU: A", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = "H.E.V. Mark 4 suit with Alpha version colors.", //new item description
    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("sprites/hev_mark4_withhelmet_earlyver.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //load textures for each layer (see Human textures folder in this repository)
        var skin = ModAPI.LoadTexture("sprites/hev_mark4_withhelmet_earlyver.png");
        var flesh = ModAPI.LoadTexture("sprites/fleshthing.png");
        var bone = ModAPI.LoadTexture("sprites/boneguy_lol.png");

        //get person
        //get person
                    var person = Instance.GetComponent<PersonBehaviour>();


              foreach (var head in person.Limbs)
                                {
                                    head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                }

                    person.SetBodyTextures(skin, flesh, bone, 1);

                                foreach (var body in person.Limbs)
                                {

                                     body.Health *= 1.5f;
                                }
    }
}
);
}}};
